  MEMBER('GdpEx')

  INCLUDE('SOURCE\GDIPLUS.INC')

LOC:hDc           HDC
LOC:hWnd          HWND
LOC:Canvas        LONG
LOC:Win           &WINDOW
LOC:XPos          LONG
LOC:YPos          LONG
LOC:Wid           LONG
LOC:Hgt           LONG
LOC:Color         LONG

hpix              SHORT
vpix              SHORT
SzPallete         LONG

LOC:HPen          HPEN
LOC:OldPen        HPEN

Token     LONG                        ! Needed to close GDI+
GpInput   LIKE(GdiplusStartupInput)   !

LOC:res   LONG

  MAP
RGBtoARGB     PROCEDURE(LONG ColorRef, BYTE Alpha = 0FFh),LONG
  END

!--------------------------------------------------------------------------------------
!    GDI+
!--------------------------------------------------------------------------------------
TestGDIPlus PROCEDURE

win  WINDOW('Test GDI+'),AT(,,304,230),CENTER,HVSCROLL,SYSTEM,RESIZE
        REGION,AT(2,2,300,211),USE(?Canvas),SCROLL,COLOR(COLOR:Red)
     END

graphics   LONG

  CODE

  OPEN(Win)
  Win{PROP:pixels} = 1
  DISPLAY

  DO InitAPI

  DO GdiplusDraw

  ACCEPT
  END

  DO KillAPI

  CLOSE(Win)

!-------------------------------------------------------------------------
!  WinAPI
!-------------------------------------------------------------------------
InitAPI ROUTINE
  LOC:Win   &= Win
  LOC:Canvas = ?Canvas
  LOC:hWND   = LOC:Win{PROP:ClientHandle}
  LOC:hDC    = GetDC(LOC:hWND)

? ASSERT(LOC:hDC <> 0)

  LOC:Win{PROP:Pixels} = True

  LOC:XPos = LOC:Win$LOC:Canvas{PROP:XPos}
  LOC:YPos = LOC:Win$LOC:Canvas{PROP:YPos}
  LOC:Wid = LOC:Win$LOC:Canvas{PROP:Width}
  LOC:Hgt = LOC:Win$LOC:Canvas{PROP:Height}

!-------------------------------------------------------------------------
!    WinAPI
!-------------------------------------------------------------------------
KillAPI ROUTINE
  ReleaseDC(LOC:hWND, LOC:hDC)

!-------------------------------------------------------------------------
!  GDI+
!-------------------------------------------------------------------------
GdiplusDraw ROUTINE
 DATA
ROU:RetResult LONG
 CODE

   GpInput.GdiplusVersion = 1

   ROU:RetResult = GdiplusStartup(Address(token), Address(GpInput), 0)

   IF ROU:RetResult <> gpOk
      Message('  GDI+ ! ' & Format(ROU:RetResult))
   ELSE
      LOC:res = GdipCreateFromHDC(LOC:hDc, Address(graphics)) ! Initialize the graphics class - required for all drawing
      DO GDIPlusTest
      LOC:res = GdipDeleteGraphics(graphics)
      LOC:res = GdiplusShutdown(token)
   END

!-------------------------------------------------------------------------
!    GDI+
!-------------------------------------------------------------------------
GDIPlusTest ROUTINE
   DO GDIPlusDrawScaling
   DO GdiplusDrawFormatText
   DO GdiplusDrawText
   DO GdiplusDrawEllipse
   DO GdiplusDrawLine
   DO GdiplusDrawCustomDashed
   DO GdiplusDrawCurves
   DO GdiplusDrawRotated

!-------------------------------------------------------------------------
!
!-------------------------------------------------------------------------
GdiplusDrawScaling ROUTINE
 DATA

img       LONG                
imgHeight LONG
imgWidth  LONG

lngHeight LONG
lngWidth  LONG

BmpFile   STRING(6)

BStr      BSTRING
LOC:Addr  LONG
FileName  STRING(64)

 CODE

   FileName = '1.bmp'

   BStr  = FileName
   LOC:Addr = Address(BStr)                                   !   UNICODE
   Peek(LOC:Addr,LOC:Addr)

   LOC:res = GdipLoadImageFromFile(LOC:Addr,Address(img))     !    

   ! Get the image height and width
   LOC:res = GdipGetImageHeight(img, Address(lngHeight))
   LOC:res = GdipGetImageWidth(img, Address(lngWidth))
   
   !**** If you don't pass a width and height when drawing, the image is auto-scaled!! ****
   LOC:res = GdipDrawImage(graphics, img, 10, 10) ! Auto-Scaled

   ! Draw the image with no shrinking or stretching
   LOC:res = GdipDrawImageRectI(graphics, img, 450, 10, lngWidth, lngHeight)
   
   ! Shrink the image using low-quality interpolation.
   LOC:res = GdipSetInterpolationMode(graphics, InterpolationModeNearestNeighbor)
   LOC:res = GdipDrawImageRectRectI(graphics, img, 350, 150, 0.6 * lngWidth, 0.6 * lngHeight, 0, 0, lngWidth, lngHeight, gpUnitPixel)
   
   ! Shrink the image using medium-quality interpolation.
  LOC:res = GdipSetInterpolationMode(graphics, InterpolationModeHighQualityBilinear)
  LOC:res = GdipDrawImageRectRectI(graphics, img, 150, 150, 0.6 * lngWidth, 0.6 * lngHeight, 0, 0, lngWidth, lngHeight, gpUnitPixel)
   
   ! Shrink the image using high-quality interpolation.
  LOC:res = GdipSetInterpolationMode(graphics, InterpolationModeHighQualityBicubic)
  LOC:res = GdipDrawImageRectRectI(graphics, img, 190, 250, 0.6 * lngWidth, 0.6 * lngHeight, 0, 0, lngWidth, lngHeight, gpUnitPixel)
   
   ! NOTES: Since we are shrinking the entire image, we could just as well have called
   !        the GdipDrawImageRectI function, which would simply things - but our goal must
   !        be make life hellish!

   LOC:res = GdipDisposeImage(img) ! Delete the image

!-------------------------------------------------------------------------
!     GDI+
!-------------------------------------------------------------------------
GdiplusDrawFormatText ROUTINE
 DATA
Pen           LONG
brush         LONG
fontFam       LONG
curFont       LONG
rcLayout      Like(RECTF)   ! Designates the string drawing bounds

strFormat     LONG

BStrFont      BSTRING
LOC:AddrFont  LONG

BStr          BSTRING
LOC:AddrStr   LONG

 CODE

   LOC:res = GdipCreateSolidFill(gpRed, Address(brush))    ! Create a brush to draw the text with

   BStrFont = 'Times New Roman'
   LOC:AddrFont = Address(BStrFont)                                     !   UNICODE
   Peek(LOC:AddrFont,LOC:AddrFont)
   LOC:res = GdipCreateFontFamilyFromName(LOC:AddrFont, 0, Address(fontFam))

   ! Create the font from the specified font family name
   LOC:res = GdipCreateFont(fontFam, 20, FontStyleRegular, gpUnitPixel, Address(curFont))

   LOC:res = GdipCreateStringFormat(0, 0, Address(strFormat))
   
   ! Set up the drawing area boundary
   rcLayout.Left = 500
   rcLayout.Top = 200
   rcLayout.Right = 120
   rcLayout.Bottom = 140
   
   ! Center-justify each line of text
   LOC:res = GdipSetStringFormatAlign(strFormat, StringAlignmentCenter)
   
   ! Center the block of text (top to bottom) in the rectangle.
   LOC:res = GdipSetStringFormatLineAlign(strFormat, StringAlignmentCenter)
   
   ! Draw the string within the boundary
   BStr = 'Use StringFormat and RectF objects to center text in a rectangle.'
   LOC:AddrStr = Address(BStr)                                        !   UNICODE
   Peek(LOC:AddrStr,LOC:AddrStr)

   LOC:res = GdipDrawString(graphics, LOC:AddrStr, -1, curFont, Address(rcLayout), strFormat, brush)
   
   ! Create a pen and draw the boundary around the text
   LOC:res = GdipCreatePen1(gpBlack, 1, gpUnitPixel, Address(pen))
   LOC:res = GdipDrawRectangles(graphics, pen, Address(rcLayout), 1)
   
   ! Cleanup
   LOC:res = GdipDeletePen(Pen)                   ! Delete Pen
   LOC:res = GdipDeleteStringFormat(strFormat)    ! Delete strFormat
   LOC:res = GdipDeleteFont(curFont)              ! Delete the font object
   LOC:res = GdipDeleteFontFamily(fontFam)        ! Delete the font family object
   LOC:res = GdipDeleteBrush(brush)               ! Delete Brush

!-------------------------------------------------------------------------
!    GDI+
!-------------------------------------------------------------------------
GdiplusDrawText ROUTINE
 DATA

brush    LONG
fontFam  LONG
curFont  LONG
rcLayout Like(RECTF)   ! Designates the string drawing bounds

BStrFont      BSTRING
LOC:AddrFont  LONG

BStr          BSTRING
LOC:AddrStr   LONG

 CODE

   LOC:res = GdipCreateSolidFill(gpBlue, Address(brush))    ! Create a brush to draw the text with

   BStrFont = 'Times New Roman'
   LOC:AddrFont = Address(BStrFont)                                     !   UNICODE
   Peek(LOC:AddrFont,LOC:AddrFont)
   LOC:res = GdipCreateFontFamilyFromName(LOC:AddrFont, 0, Address(fontFam))

   ! Create the font from the specified font family name
   LOC:res = GdipCreateFont(fontFam, 48, FontStyleRegular, gpUnitPixel, Address(curFont))
   
   ! Set up a drawing area, NOTE! Leaving the right and bottom values at zero means there is no boundary

   rcLayout.Left   = 100
   rcLayout.Top    = 100
!  rcLayout.Right  = 200   !    ,  
!  rcLayout.Bottom = 100   !      

   ! This function allows us to alter the text quality. We'll use the worst quality first.

   LOC:res = GdipSetTextRenderingHint(graphics, TextRenderingHintSingleBitPerPixel)

   BStr = '  1 (GDI+)'
   LOC:AddrStr = Address(BStr)                                       !   UNICODE
   Peek(LOC:AddrStr,LOC:AddrStr)


   LOC:res = GdipDrawString(graphics, LOC:AddrStr, Len(Clip(BStr)), curFont, Address(rcLayout), 0, Brush)


   LOC:res = GdipTranslateWorldTransform(graphics,-100,-100, MatrixOrderAppend)   !   
   LOC:res = GdipRotateWorldTransform(graphics, 30, MatrixOrderAppend)            ! 
   LOC:res = GdipTranslateWorldTransform(graphics,100,100, MatrixOrderAppend)     ! 

   rcLayout.Left = 100                                                  ! Set up another drawing area
   rcLayout.Top  = 100

   BStr = '  2 (GDI+)'
   LOC:AddrStr = Address(BStr)                                          !   UNICODE
   Peek(LOC:AddrStr,LOC:AddrStr)

   LOC:res = GdipSetSolidFillColor(Brush,gpYellow)
   LOC:res = GdipSetTextRenderingHint(graphics, TextRenderingHintAntiAlias)
   LOC:res = GdipDrawString(graphics, LOC:AddrStr, Len(Clip(BStr)), curFont, Address(rcLayout), 0, Brush)

   LOC:res = GdipResetWorldTransform(graphics)

   LOC:res = GdipDeleteFont(curFont)        ! Delete the font object
   LOC:res = GdipDeleteFontFamily(fontFam)  ! Delete the font family object

   LOC:res = GdipDeleteBrush(brush)

!-------------------------------------------------------------------------
!    GDI+
!-------------------------------------------------------------------------
GdiplusDrawEllipse   ROUTINE
 DATA
brush         LONG
                                             
 CODE
   LOC:res = GdipCreateSolidFill(RGBtoARGB(gpGreen,115), Address(brush))
!   LOC:res = GdipFillRectangleI(graphics, brush, 20, 20, 100, 100)
   LOC:res = GdipDeleteBrush(brush)
  
   LOC:res = GdipCreateHatchBrush(HatchStyleDiagonalCross, gpWhite, gpBlue, Address(brush))  ! Create the pattern brush
   LOC:res = GdipFillEllipseI(graphics, brush, 50, 50, 150, 80)                !  Draw an ellipse
   LOC:res = GdipDeleteBrush(brush)                                            !  Cleanup

   LOC:res = GdipCreateHatchBrush(HatchStyleDottedGrid, gpGreen, gpWhite, Address(brush))  ! Create the pattern brush
   LOC:res = GdipFillEllipseI(graphics, brush, 60, 60, 100, 60)                !  Draw an ellipse
   LOC:res = GdipDeleteBrush(brush)

   LOC:res = GdipCreateHatchBrush(HatchStyleDiagonalCross, gpWhite, RGBtoARGB(gpBlue,51), Address(brush))  ! Create the pattern brush
   LOC:res = GdipFillEllipseI(graphics, brush, 150, 150, 150, 80)                !  Draw an ellipse
   LOC:res = GdipDeleteBrush(brush)                                            !  Cleanup

!-------------------------------------------------------------------------
!    GDI+
!-------------------------------------------------------------------------
GdiplusDrawLine ROUTINE
 DATA
result  LONG
pen     LONG
 CODE

   LOC:res = GdipCreatePen1(gpRed, 8, gpUnitPixel, Address(pen))

   LOC:res = GdipSetPenColor(pen,gpYellow)
   LOC:res = GdipSetPenStartCap(pen, LineCapArrowAnchor)                       
   LOC:res = GdipSetPenEndCap(pen, LineCapRoundAnchor)
   LOC:res = GdipDrawLineI(graphics, pen, 140, 140, 300, 300)

   LOC:res = GdipSetPenWidth(pen,15)
   LOC:res = GdipSetPenColor(pen,gpRed)
   LOC:res = GdipSetPenStartCap(pen, LineCapSquare)
   LOC:res = GdipSetPenEndCap(pen, LineCapTriangle)
   LOC:res = GdipDrawLineI(graphics, pen, 20, 100, 200, 20)

   LOC:res = GdipSetPenColor(pen,gpBlue)
   LOC:res = GdipDrawLineI(graphics, pen, 20, 100, 100, 100)

   LOC:res = GdipDeletePen(pen)                                                

!-------------------------------------------------------------------------
!      GDI+
!-------------------------------------------------------------------------
GdiplusDrawCustomDashed ROUTINE
 DATA
result     LONG
pen        LONG
DashValues SREAL,DIM(4)
 CODE

   ! Set the dash intervals
   ! The dashes are in an on/off pattern and continually repeat for the length of the line

   dashValues[1] = 2    ! Show 2 * penwidth
   dashValues[2] = 4    ! Hide 4 * penwidth
   dashValues[3] = 6    ! Show 6 * penwidth
   dashValues[4] = 8    ! Hide 8 * pendwith

   LOC:res = GdipCreatePen1(gpBlack, 20, gpUnitPixel, Address(pen))
   LOC:res = GdipSetPenDashArray(pen, Address(DashValues[1]), 4)   ! Set the dash pattern
   LOC:res = GdipDrawLineI(graphics, pen, 10, 10, 500,300)         ! Draw the line
   LOC:res = GdipDeletePen(pen)                                    ! Cleanup
 

!-------------------------------------------------------------------------
!      GDI+
!-------------------------------------------------------------------------
GdiplusDrawCurves ROUTINE
 DATA
pen        LONG
brush      LONG
points     Like(POINTL),DIM(5)

 CODE

   points[1].x = 100
   points[1].y = 200

   points[2].x = 150
   points[2].y = 180

   points[3].x = 200
   points[3].y = 120

   points[4].x = 250
   points[4].y = 180

   points[5].x = 300
   points[5].y = 200

   LOC:res = GdipCreatePen1(gpLinen, 10, gpUnitPixel, Address(pen))                      ! Create a pen to draw with
   LOC:res = GdipSetCompositingQuality(graphics, CompositingQualityGammaCorrected)   ! Gamma correction is nice, though slower...
   LOC:res = GdipSetSmoothingMode(graphics, SmoothingModeAntiAlias)                  ! Draw the curve w/ anti-aliasing
   LOC:res = GdipDrawCurveI(graphics, pen, Address(Points), 5)

   LOC:res = GdipSetPenColor(pen,gpYellow)
   LOC:res = GdipDrawLinesI(graphics, pen, Address(Points), 3)

   points[1].x = 150
   points[1].y = 150

   points[2].x = 160
   points[2].y = 200

   points[3].x = 130
   points[3].y = 250

   points[4].x = 180
   points[4].y = 270

   points[5].x = 20
   points[5].y = 100


  LOC:res = GdipCreateSolidFill(RGBtoARGB(gpGreen,115), Address(brush))
  LOC:Res = GdipFillPolygonI(Graphics, Brush, Address(points),5,0)
  LOC:res = GdipDeleteBrush(brush)

  LOC:Res = GdipDrawPolygonI(Graphics, Pen, Address(points),5)
  LOC:res = GdipDeletePen(pen)                                                      ! Cleanup

!-------------------------------------------------------------------------
!        GDI+
!-------------------------------------------------------------------------
GdiplusDrawRotated ROUTINE
 DATA

img       LONG                
imgHeight LONG
imgWidth  LONG

BmpFile   STRING(6)

BStr      BSTRING
LOC:Addr  LONG
FileName  STRING(64)

 CODE
   FileName = '1.jpg'

   BStr  = FileName
   LOC:Addr = Address(BStr)                                            !   UNICODE
   Peek(LOC:Addr,LOC:Addr)

   LOC:res = GdipLoadImageFromFile(LOC:Addr,Address(img))                        !    

   LOC:res = GdipGetImageHeight(img, Address(imgHeight))                         !     
   LOC:res = GdipGetImageWidth(img, Address(imgWidth))
   LOC:res = GdipDrawImageRect(graphics, img, 20, 250, imgWidth, imgHeight)
   LOC:res = GdipRotateWorldTransform(graphics, 30, MatrixOrderAppend)
   LOC:res = GdipDrawImageRect(graphics, img, 420, 100, imgWidth*0.5, imgHeight*0.5) !     X  Y
   LOC:res = GdipDisposeImage(img)                                                   !  
                                  
!----------------------------------------------------------------------------------------------------------
!     RGB   ARGB
!----------------------------------------------------------------------------------------------------------
RGBtoARGB PROCEDURE(LONG ColorRef, BYTE Alpha)

GARGB GROUP
b  BYTE
g  BYTE
r  BYTE
a  BYTE
 END

LARGB  ULONG,OVER(GARGB)

 CODE
  GARGB.a = Alpha
  GARGB.r = BAND(ColorRef,00000FFh)
  GARGB.g = BSHIFT(BAND(ColorRef,000FF00h),-8)
  GARGB.b = BSHIFT(BAND(ColorRef,0FF0000h),-16)
  RETURN(LARGB)

!----------------------------------------------------------------------------------------------------------
